Index: src/Helpers/MemDebug.cpp
===================================================================
--- src/Helpers/MemDebug.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/Helpers/MemDebug.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -9,6 +9,10 @@
 #include <cstdlib>
 #include <cstring>
+#include <boost/thread.hpp>
 
 using namespace std;
+
+#ifndef NDBEGUG
+#ifndef NO_MEMDEBUG
 
 namespace Memory {
@@ -40,4 +44,6 @@
   };
 
+  boost::mutex memorylock;
+
   // start and end of the doubly-linked list
   entry_t *begin=0;
@@ -128,4 +134,7 @@
 void *operator new(size_t nbytes,const char* file, int line) throw(std::bad_alloc) {
 
+  // we need to lock, so that no one changes the linked list while we are here
+  boost::mutex::scoped_lock guard(Memory::memorylock);
+
   // to avoid allocations of 0 bytes if someone screws up
   // allocation with 0 byte size are undefined behavior, so we are
@@ -153,4 +162,5 @@
   // build the entry in front of the space
   Memory::entry_t *entry = (Memory::entry_t*) res;
+  memset(res,0,entrySpace);
   entry->info.nbytes = nbytes;
   entry->info.isUsed = true;
@@ -203,4 +213,12 @@
 
 void operator delete(void *ptr) throw() {
+  if(!ptr){
+    cerr << "Warning: Deleting NULL pointer" << endl;
+    return;
+  }
+
+  // we need to lock, so the linked list does not changed while we are in here
+  boost::mutex::scoped_lock guard(Memory::memorylock);
+
   // get the size for the entry, including alignment
   static const size_t entrySpace = Memory::doAlign(sizeof(Memory::entry_t));
@@ -211,7 +229,7 @@
   // let's see if the checksum is still matching
   if(Memory::calcChecksum(&entry->info)!=entry->checksum){
-    cout << "Possible memory corruption detected!" << endl;
-    cout << "Trying to recover allocation information..." << endl;
-    cout << "Memory was allocated at " << entry->info.file << ":" << entry->info.line << endl;
+    cerr << "Possible memory corruption detected!" << endl;
+    cerr << "Trying to recover allocation information..." << endl;
+    cerr << "Memory was allocated at " << entry->info.file << ":" << entry->info.line << endl;
     terminate();
   }
@@ -240,2 +258,4 @@
   operator delete(ptr);
 }
+#endif
+#endif
Index: src/Helpers/MemDebug.hpp
===================================================================
--- src/Helpers/MemDebug.hpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/Helpers/MemDebug.hpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -21,4 +21,10 @@
  * your sourcefiles.
  */
+#ifndef NDEBUG
+#ifndef NO_MEMDEBUG
+
+#ifndef MEMDEBUG
+#define MEMDEBUG
+#endif
 
 namespace Memory {
@@ -56,3 +62,20 @@
 #define new new(__FILE__,__LINE__)
 
+#endif
+#endif
+
+
+#ifndef MEMDEBUG
+// memory debugging was disabled
+
+namespace Memory {
+  inline void getState(){}
+
+  template <typename T>
+  inline T *ignore(T* ptr){
+    return ptr;
+  }
+}
+
+#endif
 #endif /* MEMDEBUG_HPP_ */
Index: src/Legacy/oldmenu.cpp
===================================================================
--- src/Legacy/oldmenu.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/Legacy/oldmenu.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -424,5 +424,5 @@
 void oldmenu::RemoveAtoms(molecule *mol)
 {
-  atom *first, *second;
+  atom *second;
   int axis;
   double tmp1, tmp2;
@@ -447,14 +447,14 @@
       break;
     case 'b':
-      second = mol->AskAtom("Enter number of atom as reference point: ");
-      Log() << Verbose(0) << "Enter radius: ";
-      cin >> tmp1;
-      first = mol->start;
-      second = first->next;
-      while(second != mol->end) {
-        first = second;
-        second = first->next;
-        if (first->x.DistanceSquared(second->x) > tmp1*tmp1) // distance to first above radius ...
-          mol->RemoveAtom(first);
+      {
+        second = mol->AskAtom("Enter number of atom as reference point: ");
+        Log() << Verbose(0) << "Enter radius: ";
+        cin >> tmp1;
+        molecule::iterator runner;
+        for (molecule::iterator iter = mol->begin(); iter != mol->end(); ) {
+          runner = iter++;
+          if ((*runner)->x.DistanceSquared((*runner)->x) > tmp1*tmp1) // distance to first above radius ...
+            mol->RemoveAtom((*runner));
+        }
       }
       break;
@@ -466,12 +466,10 @@
       Log() << Verbose(0) << "Upper boundary: ";
       cin >> tmp2;
-      first = mol->start;
-      second = first->next;
-      while(second != mol->end) {
-        first = second;
-        second = first->next;
-        if ((first->x[axis] < tmp1) || (first->x[axis] > tmp2)) {// out of boundary ...
-          //Log() << Verbose(0) << "Atom " << *first << " with " << first->x.x[axis] << " on axis " << axis << " is out of bounds [" << tmp1 << "," << tmp2 << "]." << endl;
-          mol->RemoveAtom(first);
+      molecule::iterator runner;
+      for (molecule::iterator iter = mol->begin(); iter != mol->end(); ) {
+        runner = iter++;
+        if (((*runner)->x[axis] < tmp1) || ((*runner)->x[axis] > tmp2)) {// out of boundary ...
+          //Log() << Verbose(0) << "Atom " << *(*runner) << " with " << (*runner)->x.x[axis] << " on axis " << axis << " is out of bounds [" << tmp1 << "," << tmp2 << "]." << endl;
+          mol->RemoveAtom((*runner));
         }
       }
@@ -516,15 +514,13 @@
         min[i] = 0.;
 
-      second = mol->start;
-      while ((second->next != mol->end)) {
-        second = second->next; // advance
-        Z = second->type->Z;
+      for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
+        Z = (*iter)->type->Z;
         tmp1 = 0.;
-        if (first != second) {
-          x = first->x - second->x;
+        if (first != (*iter)) {
+          x = first->x - (*iter)->x;
           tmp1 = x.Norm();
         }
         if ((tmp1 != 0.) && ((min[Z] == 0.) || (tmp1 < min[Z]))) min[Z] = tmp1;
-        //Log() << Verbose(0) << "Bond length between Atom " << first->nr << " and " << second->nr << ": " << tmp1 << " a.u." << endl;
+        //Log() << Verbose(0) << "Bond length between Atom " << first->nr << " and " << ((*iter)->nr << ": " << tmp1 << " a.u." << endl;
       }
       for (int i=MAX_ELEMENTS;i--;)
@@ -609,5 +605,5 @@
   Log() << Verbose(0) << "What's the desired bond order: ";
   cin >> Order1;
-  if (mol->first->next != mol->last) {  // there are bonds
+  if (mol->hasBondStructure()) {
     start = clock();
     mol->FragmentMolecule(Order1, configuration);
@@ -755,16 +751,12 @@
     Log() << Verbose(0) << "State the factor: ";
     cin >> faktor;
-
-    mol->CountAtoms(); // recount atoms
-    if (mol->AtomCount != 0) {  // if there is more than none
-      count = mol->AtomCount;  // is changed becausing of adding, thus has to be stored away beforehand
+    if (mol->getAtomCount() != 0) {  // if there is more than none
+      count = mol->getAtomCount();  // is changed becausing of adding, thus has to be stored away beforehand
       Elements = new const element *[count];
       vectors = new Vector *[count];
       j = 0;
-      first = mol->start;
-      while (first->next != mol->end) { // make a list of all atoms with coordinates and element
-        first = first->next;
-        Elements[j] = first->type;
-        vectors[j] = &first->x;
+      for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
+        Elements[j] = (*iter)->type;
+        vectors[j] = &(*iter)->x;
         j++;
       }
@@ -783,5 +775,5 @@
         }
       }
-      if (mol->first->next != mol->last) // if connect matrix is present already, redo it
+      if (mol->hasBondStructure())
         mol->CreateAdjacencyList(mol->BondDistance, configuration->GetIsAngstroem(), &BondGraph::CovalentMinMaxDistance, NULL);
       // free memory
@@ -1025,14 +1017,12 @@
     return;
   }
-  atom *Walker = mol->start;
 
   // generate some KeySets
   Log() << Verbose(0) << "Generating KeySets." << endl;
-  KeySet TestSets[mol->AtomCount+1];
+  KeySet TestSets[mol->getAtomCount()+1];
   i=1;
-  while (Walker->next != mol->end) {
-    Walker = Walker->next;
+  for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
     for (int j=0;j<i;j++) {
-      TestSets[j].insert(Walker->nr);
+      TestSets[j].insert((*iter)->nr);
     }
     i++;
@@ -1040,12 +1030,15 @@
   Log() << Verbose(0) << "Testing insertion of already present item in KeySets." << endl;
   KeySetTestPair test;
-  test = TestSets[mol->AtomCount-1].insert(Walker->nr);
-  if (test.second) {
-    Log() << Verbose(1) << "Insertion worked?!" << endl;
+  molecule::const_iterator iter = mol->begin();
+  if (iter != mol->end()) {
+    test = TestSets[mol->getAtomCount()-1].insert((*iter)->nr);
+    if (test.second) {
+      Log() << Verbose(1) << "Insertion worked?!" << endl;
+    } else {
+      Log() << Verbose(1) << "Insertion rejected: Present object is " << (*test.first) << "." << endl;
+    }
   } else {
-    Log() << Verbose(1) << "Insertion rejected: Present object is " << (*test.first) << "." << endl;
-  }
-  TestSets[mol->AtomCount].insert(mol->end->previous->nr);
-  TestSets[mol->AtomCount].insert(mol->end->previous->previous->previous->nr);
+    eLog() << Verbose(1) << "No atoms to test double insertion." << endl;
+  }
 
   // constructing Graph structure
@@ -1055,10 +1048,10 @@
   // insert KeySets into Subgraphs
   Log() << Verbose(0) << "Inserting KeySets into Subgraph class." << endl;
-  for (int j=0;j<mol->AtomCount;j++) {
+  for (int j=0;j<mol->getAtomCount();j++) {
     Subgraphs.insert(GraphPair (TestSets[j],pair<int, double>(counter++, 1.)));
   }
   Log() << Verbose(0) << "Testing insertion of already present item in Subgraph." << endl;
   GraphTestPair test2;
-  test2 = Subgraphs.insert(GraphPair (TestSets[mol->AtomCount],pair<int, double>(counter++, 1.)));
+  test2 = Subgraphs.insert(GraphPair (TestSets[mol->getAtomCount()],pair<int, double>(counter++, 1.)));
   if (test2.second) {
     Log() << Verbose(1) << "Insertion worked?!" << endl;
Index: src/Makefile.am
===================================================================
--- src/Makefile.am	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/Makefile.am	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -113,12 +113,14 @@
   Descriptors/AtomTypeDescriptor.cpp \
   Descriptors/MoleculeDescriptor.cpp \
-  Descriptors/MoleculeIdDescriptor.cpp 
+  Descriptors/MoleculeIdDescriptor.cpp \ 
+  Descriptors/MoleculePtrDescriptor.cpp 
 				   
-				   
+
 DESCRIPTORHEADER = Descriptors/AtomDescriptor.hpp \
   Descriptors/AtomIdDescriptor.hpp \
   Descriptors/AtomTypeDescriptor.hpp \
   Descriptors/MoleculeDescriptor.hpp \
-  Descriptors/MoleculeIdDescriptor.hpp
+  Descriptors/MoleculeIdDescriptor.hpp \
+  Descriptors/MoleculePtrDescriptor.hpp
 				   
 EXCEPTIONSOURCE = Exceptions/CustomException.cpp \
@@ -157,8 +159,6 @@
   Line.cpp \
   linkedcell.cpp \
-  lists.cpp \
   log.cpp \
   logger.cpp \
-  memoryusageobserver.cpp \
   moleculelist.cpp \
   molecule.cpp \
@@ -171,9 +171,11 @@
   periodentafel.cpp \
   Plane.cpp \
+  Space.cpp \
   tesselation.cpp \
   tesselationhelpers.cpp \
   triangleintersectionlist.cpp \
+  vector.cpp \
+  vector_ops.cpp \
   verbose.cpp \
-  vector_ops.cpp \
   World.cpp
 
@@ -206,6 +208,4 @@
   log.hpp \
   logger.hpp \
-  memoryallocator.hpp \
-  memoryusageobserver.hpp \
   molecule.hpp \
   molecule_template.hpp \
@@ -221,4 +221,10 @@
   World.hpp 
 
+# the following files are no longer used:
+#  memoryallocator.hpp \
+#  memoryallocator.cpp \
+#  memoryusageobserver.hpp \
+#  memoryusageobserver.cpp
+
 BOOST_LIB = $(BOOST_LDFLAGS) $(BOOST_MPL_LIB)
 INCLUDES = -I$(top_srcdir)/src/unittests -I$(top_srcdir)/src/Actions -I$(top_srcdir)/src/UIElements
Index: src/Patterns/Cacheable.hpp
===================================================================
--- src/Patterns/Cacheable.hpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/Patterns/Cacheable.hpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -28,5 +28,5 @@
         owner(_owner)
         {}
-      virtual T getValue()=0;
+      virtual T& getValue()=0;
       virtual void invalidate()=0;
       virtual bool isValid()=0;
@@ -46,5 +46,5 @@
         {}
 
-      virtual T getValue(){
+      virtual T& getValue(){
         // set the state to valid
         State::owner->switchState(State::owner->validState);
@@ -72,5 +72,5 @@
         {}
 
-      virtual T getValue(){
+      virtual T& getValue(){
         return content;
       }
@@ -100,5 +100,5 @@
         {}
 
-      virtual T getValue(){
+      virtual T& getValue(){
         ASSERT(0,"Cannot get a value from a Cacheable after it's Observable has died");
         // we have to return a grossly invalid reference, because no value can be produced anymore
@@ -134,5 +134,4 @@
     void subjectKilled(Observable *subject);
   private:
-
     void switchState(state_ptr newState);
 
@@ -144,5 +143,4 @@
 
     Observable *owner;
-
     boost::function<T()> recalcMethod;
 
@@ -221,5 +219,5 @@
 
     const bool isValid() const;
-    const T operator*() const;
+    const T& operator*() const;
 
     // methods implemented for base-class Observer
@@ -237,5 +235,5 @@
 
   template<typename T>
-  const T Cacheable<T>::operator*() const{
+  const T& Cacheable<T>::operator*() const{
     return recalcMethod();
   }
Index: src/Patterns/ObservedIterator.hpp
===================================================================
--- src/Patterns/ObservedIterator.hpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
+++ src/Patterns/ObservedIterator.hpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -0,0 +1,144 @@
+/*
+ * ObservedIterator.hpp
+ *
+ *  Created on: Mar 4, 2010
+ *      Author: crueger
+ */
+
+#ifndef OBSERVEDITERATOR_HPP_
+#define OBSERVEDITERATOR_HPP_
+
+#include "Patterns/Observer.hpp"
+
+#include <iterator>
+
+// we build an iterator that observes traversion of some kind of Data structure conforming to STL
+template<class _Set>
+class ObservedIterator
+    : public std::iterator<typename std::iterator_traits<typename _Set::iterator>::iterator_category,
+                           typename std::iterator_traits<typename _Set::iterator>::value_type,
+                           typename std::iterator_traits<typename _Set::iterator>::difference_type,
+                           typename std::iterator_traits<typename _Set::iterator>::pointer,
+                           typename std::iterator_traits<typename _Set::iterator>::reference>
+{
+public:
+  // Some typedefs to conform to STL-Iterator structure
+  typedef typename _Set::iterator _Iter;
+  typedef typename _Iter::value_type value_type;
+  typedef typename _Iter::difference_type difference_type;
+  typedef typename _Iter::pointer pointer;
+  typedef typename _Iter::reference reference;
+  typedef typename _Iter::iterator_category iterator_category;
+
+  ObservedIterator() :
+    protector(0)
+  {}
+
+  ObservedIterator(_Iter iter,Observable *obs) :
+    iter(iter),
+    collection(obs),
+    protector(0)
+  {}
+
+  ObservedIterator(const ObservedIterator &dest) :
+    iter(dest.iter),
+    collection(dest.collection),
+    protector(dest.copyLock())
+  {}
+
+  ~ObservedIterator(){
+    if(protector)
+      delete protector;
+  }
+
+  // standard Iterator methods
+  ObservedIterator& operator=(const ObservedIterator& dest){
+    if(&dest !=this){
+      // get the new lock first, in case the two locks point to the same observable
+      Observable::_Observable_protector *newLock = dest.copyLock();
+      if(protector)
+        delete protector;
+      protector = newLock;
+      // After the new lock is aquired we can safely set the iterator
+      iter = dest.iter;
+      // we need to know the collection, in case we still have to set the lock
+      collection = dest.collection;
+    }
+    return *this;
+  }
+
+  ObservedIterator& operator++()   // prefix
+  {
+    ++iter;
+    return *this;
+  }
+
+  ObservedIterator operator++(int) // postfix with the dummy int parameter
+  {
+    ObservedIterator ret(*this);
+    ++(*this);
+    return ret;
+  }
+
+  ObservedIterator& operator--()   // prefix
+  {
+    --iter;
+  }
+
+  ObservedIterator  operator--(int) // postfix with the dummy int parameter
+  {
+    ObservedIterator ret(*this);
+    --(*this);
+    return ret;
+  }
+
+  bool operator==(const ObservedIterator &rhs){
+    return iter==rhs.iter;
+  }
+
+  bool operator!=(const ObservedIterator &rhs){
+    return iter!=rhs.iter;
+  }
+
+  value_type operator*(){
+    // access is requested... time to get the lock
+    acquireLock();
+    return (*iter);
+  }
+
+  // when we turn into a const iterator we can loose our lock
+  operator typename _Set::const_iterator() {
+    // typecast will be handled by the typecast method of the original iterator
+    return iter;
+  }
+
+private:
+
+  /**
+   * gets the lock for the collection when needed
+   *
+   * The lock is only acquired when the first change is done, so we can be free to do
+   * anything with the iterator before that. I.e. step forward, turn into a const_iterator
+   * etc.
+   */
+  void acquireLock(){
+    if(!protector)
+      protector = new Observable::_Observable_protector(collection);
+  }
+
+  Observable::_Observable_protector *copyLock() const{
+    // we only copy if we actually carry a lock
+    if(protector){
+      return new Observable::_Observable_protector(*protector);
+    }
+    else{
+      return 0;
+    }
+  }
+
+  _Iter iter;
+  Observable *collection;
+  Observable::_Observable_protector *protector;
+};
+
+#endif /* OBSERVEDITERATOR_HPP_ */
Index: src/Patterns/Observer.cpp
===================================================================
--- src/Patterns/Observer.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/Patterns/Observer.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -82,4 +82,10 @@
 Observable::_Observable_protector::_Observable_protector(Observable *_protege) :
   protege(_protege)
+{
+  start_observer_internal(protege);
+}
+
+Observable::_Observable_protector::_Observable_protector(const _Observable_protector &dest) :
+    protege(dest.protege)
 {
   start_observer_internal(protege);
@@ -189,4 +195,5 @@
   ASSERT(callTable.count(this),"SignOff called for an Observable without Observers.");
   callees_t &callees = callTable[this];
+
   callees_t::iterator iter;
   callees_t::iterator deliter;
Index: src/Patterns/Observer.hpp
===================================================================
--- src/Patterns/Observer.hpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/Patterns/Observer.hpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -36,4 +36,7 @@
 typedef Notification *const Notification_ptr;
 
+template<class _Set>
+class ObservedIterator;
+
 /**
  * An Observer is notified by all Observed objects, when anything changes.
@@ -53,4 +56,6 @@
   friend class Observable;
   friend class Notification;
+  template<class> friend class ObservedIterator;
+
 public:
   Observer();
@@ -152,5 +157,4 @@
   static std::set<Observable*> busyObservables;
 
-
   //! @cond
   // Structure for RAII-Style notification
@@ -164,4 +168,5 @@
   public:
     _Observable_protector(Observable *);
+    _Observable_protector(const _Observable_protector&);
     ~_Observable_protector();
   private:
Index: src/Plane.cpp
===================================================================
--- src/Plane.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/Plane.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -91,4 +91,13 @@
   offset = normalVector->ScalarProduct(_offsetVector);
 }
+
+/**
+ * copy constructor
+ */
+Plane::Plane(const Plane& plane) :
+  normalVector(new Vector(*plane.normalVector)),
+  offset(plane.offset)
+{}
+
 
 Plane::~Plane()
Index: src/Plane.hpp
===================================================================
--- src/Plane.hpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/Plane.hpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -26,4 +26,5 @@
   Plane(const Vector &_normalVector, double _offset)  throw(ZeroVectorException);
   Plane(const Vector &_normalVector, const Vector &_offsetVector) throw(ZeroVectorException);
+  Plane(const Plane& plane);
   virtual ~Plane();
 
Index: src/UIElements/CommandLineUI/CommandLineDialog.cpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineDialog.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/UIElements/CommandLineUI/CommandLineDialog.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -15,4 +15,6 @@
 #include <Descriptors/MoleculeIdDescriptor.hpp>
 #include "CommandLineUI/CommandLineDialog.hpp"
+
+#include "Actions/Values.hpp"
 
 #include "element.hpp"
@@ -116,24 +118,9 @@
 
 bool CommandLineDialog::BooleanCommandLineQuery::handle() {
-  bool badInput = false;
-  char input = ' ';
-  do{
-    badInput = false;
-    Log() << Verbose(0) << getTitle();
-    cin >> input;
-    if ((input == 'y' ) || (input == 'Y')) {
-      tmp = true;
-    } else if ((input == 'n' ) || (input == 'N')) {
-      tmp = false;
-    } else {
-      badInput=true;
-      cin.clear();
-      cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
-      Log() << Verbose(0) << "Input was not of [yYnN]!" << endl;
-    }
-  } while(badInput);
-  // clear the input buffer of anything still in the line
-  cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
-  return true;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    tmp = CommandLineParser::getInstance().vm[getTitle()].as<bool>();
+    return true;
+  } else
+    return false;
 }
 
@@ -192,5 +179,9 @@
   if (CommandLineParser::getInstance().vm.count(getTitle())) {
     IdxOfMol = CommandLineParser::getInstance().vm[getTitle()].as<int>();
-    tmp = World::getInstance().getMolecule(MoleculeById(IdxOfMol));
+    cout << "IdxOfMol " << IdxOfMol << endl;
+    if (IdxOfMol >= 0)
+      tmp = World::getInstance().getMolecule(MoleculeById(IdxOfMol));
+    else
+      tmp = NULL;
     return true;
   } else
@@ -206,10 +197,10 @@
 
 bool CommandLineDialog::VectorCommandLineQuery::handle() {
-  vector<double> temp;
-  if (CommandLineParser::getInstance().vm.count(getTitle())) {
-    temp = CommandLineParser::getInstance().vm[getTitle()].as<vector<double> >();
-    assert((temp.size() == 3) && "Vector from command line does not have three components.");
-    for (int i=0;i<NDIM;i++)
-      tmp->at(i) = temp[i];
+  VectorValue temp;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    temp = CommandLineParser::getInstance().vm[getTitle()].as< VectorValue >();
+    tmp->at(0) = temp.x;
+    tmp->at(1) = temp.y;
+    tmp->at(2) = temp.z;
     return true;
   } else
@@ -226,10 +217,13 @@
 
 bool CommandLineDialog::BoxCommandLineQuery::handle() {
-  vector<double> temp;
-  if (CommandLineParser::getInstance().vm.count(getTitle())) {
-    temp = CommandLineParser::getInstance().vm[getTitle()].as<vector<double> >();
-    assert((temp.size() == 6) && "Symmetric box matrix from command line does not have six components.");
-    for (int i=0;i<6;i++)
-      tmp[i] = temp[i];
+  BoxValue temp;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    temp = CommandLineParser::getInstance().vm[getTitle()].as< BoxValue >();
+    tmp[0] = temp.xx;
+    tmp[1] = temp.xy;
+    tmp[2] = temp.xz;
+    tmp[3] = temp.yy;
+    tmp[4] = temp.yz;
+    tmp[5] = temp.zz;
     return true;
   } else
Index: src/UIElements/CommandLineUI/CommandLineWindow.cpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineWindow.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/UIElements/CommandLineUI/CommandLineWindow.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -73,9 +73,9 @@
 CommandLineWindow::~CommandLineWindow()
 {
-  // go through all possible actions
-  for(std::map<const std::string,Action*>::iterator ActionRunner = ActionRegistry::getInstance().getBeginIter(); ActionRegistry::getInstance().getBeginIter() != ActionRegistry::getInstance().getEndIter(); ActionRunner = ActionRegistry::getInstance().getBeginIter()) {
-    ActionRegistry::getInstance().unregisterAction(ActionRunner->second);
-    delete(ActionRunner->second);
-  }
+//  // go through all possible actions
+//  for(std::map<const std::string,Action*>::iterator ActionRunner = ActionRegistry::getInstance().getBeginIter(); ActionRegistry::getInstance().getBeginIter() != ActionRegistry::getInstance().getEndIter(); ActionRunner = ActionRegistry::getInstance().getBeginIter()) {
+//    ActionRegistry::getInstance().unregisterAction(ActionRunner->second);
+//    delete(ActionRunner->second);
+//  }
 
   delete statusIndicator;
Index: src/UIElements/Dialog.cpp
===================================================================
--- src/UIElements/Dialog.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/UIElements/Dialog.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -166,5 +166,5 @@
   target(_target)
 {
-tmp = new Vector();
+  tmp = new Vector();
 }
 
@@ -193,6 +193,7 @@
 
 void Dialog::BoxQuery::setResult() {
-  for (int i=0;i<6;i++)
-    *target[i] = tmp[i];
+  for (int i=0;i<6;i++) {
+    (*target)[i] = tmp[i];
+  }
 }
 
Index: src/World.cpp
===================================================================
--- src/World.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/World.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -87,9 +87,11 @@
   delete[](defaultName);
   const int length = strlen(name);
-  defaultName = new char[length+2];
-  if (length < MAXSTRINGSIZE)
+  if (length < MAXSTRINGSIZE) {
+    defaultName = new char[length+2];
     strncpy(defaultName, name, length);
-  else
-    strcpy(defaultName, "none");
+  } else {
+    defaultName = new char[MAXSTRINGSIZE];
+    strncpy(defaultName, "none", MAXSTRINGSIZE-1);
+  }
 };
 
